﻿-- **********************************************************************
-- GnomTEC Babel
-- Version: 5.3.0.9
-- Author: GnomTEC
-- Copyright 2011-2013 by GnomTEC
-- http://www.gnomtec.de/
-- **********************************************************************
-- load localization first.
local L = LibStub("AceLocale-3.0"):GetLocale("GnomTEC_Babel")

-- ----------------------------------------------------------------------
-- Legacy global variables and constants (will be deleted in future)
-- ----------------------------------------------------------------------

GnomTEC_Babel_Options = {
	["Enabled"] = true,
	["LanguageID"] = select(2, GetLanguageByIndex(1)),
	["LanguageSelectorEnabled"] = true,
	["AdditionalLanguages"] ={},
}

-- ----------------------------------------------------------------------
-- Addon global Constants (local)
-- ----------------------------------------------------------------------
-- Horde
local LANGUAGE_ORCISH					= 1
local LANGUAGE_TAURAHE 					= 3
local LANGUAGE_THALASSIAN				= 10
local LANGUAGE_ZANDALI					= 14
local LANGUAGE_FORSAKEN					= 33
local LANGUAGE_GOBLIN					= 40
local LANGUAGE_PANDAREN_HORDE			= 44
-- Alliance
local LANGUAGE_DARNASSIAN				= 2
local LANGUAGE_DWARVISH					= 6
local LANGUAGE_COMMON					= 7
local LANGUAGE_GNOMISH					= 13
local LANGUAGE_DRAENEI					= 35
local LANGUAGE_PANDAREN_ALLIANCE		= 43
-- Other
local LANGUAGE_Demonic					= 8

local MaxUserDefinedLanguages = 5

-- ----------------------------------------------------------------------
-- Addon global variables (local)
-- ----------------------------------------------------------------------

-- Main options menue with general addon information
local optionsMain = {
	name = "GnomTEC Babel",
	type = "group",
	args = {
		descriptionTitle = {
			order = 1,
			type = "description",
			name = L["L_OPTIONS_TITLE"],
		},
		babelOptionEnable = {
			type = "toggle",
			name = L["L_OPTIONS_ENABLE"],
			desc = "",
			set = function(info,val) GnomTEC_Babel_Options["Enabled"] = val;  end,
			get = function(info) return GnomTEC_Babel_Options["Enabled"] end,
			width = 'full',
			order = 2
		},
		babelOptionLanguageSelectorEnable = {
			type = "toggle",
			name = L["L_OPTIONS_BUTTON"],
			desc = "",
			set = function(info,val) GnomTEC_Babel_Options["LanguageSelectorEnabled"] = val; if (GnomTEC_Babel_Options["LanguageSelectorEnabled"]) then GNOMTEC_BABEL_FRAME:Show(); else GNOMTEC_BABEL_FRAME:Hide(); end;  end,
			get = function(info) return GnomTEC_Babel_Options["LanguageSelectorEnabled"] end,
			width = 'full',
			order = 3
		},
		descriptionAbout = {
			name = "About",
			type = "group",
			guiInline = true,
			order = 4,
			args = {
				descriptionVersion = {
				order = 1,
				type = "description",			
				name = "|cffffd700".."Version"..": ".._G["GREEN_FONT_COLOR_CODE"]..GetAddOnMetadata("GnomTEC_Babel", "Version"),
				},
				descriptionAuthor = {
					order = 2,
					type = "description",
					name = "|cffffd700".."Autor"..": ".."|cffff8c00".."GnomTEC",
				},
				descriptionEmail = {
					order = 3,
					type = "description",
					name = "|cffffd700".."Email"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."info@gnomtec.de",
				},
				descriptionWebsite = {
					order = 4,
					type = "description",
					name = "|cffffd700".."Website"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."http://www.gnomtec.de/",
				},
				descriptionLicense = {
					order = 5,
					type = "description",
					name = "|cffffd700".."Copyright"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."(c)2011-2013 by GnomTEC",
				},
			}
		},
		descriptionLogo = {
			order = 5,
			type = "description",
			name = "",
			image = "Interface\\AddOns\\GnomTEC_Babel\\Textures\\GnomTEC-Logo",
			imageCoords = {0.0,1.0,0.0,1.0},
			imageWidth = 512,
			imageHeight = 128,
		},
	}
}

local optionsLanguages = {
	name = L["L_OPTIONS_LANGUAGES"],
	type = 'group',
	args = {
		language1 = {
			type = "input",
			name = L["L_OPTIONS_LANGUAGES_1"],
			desc = "",
			disabled = function(info) return not GnomTEC_Babel_Options["Enabled"] end,
			set = function(info,val) GnomTEC_Babel_Options["AdditionalLanguages"][1] = val end,
	   	get = function(info) return GnomTEC_Babel_Options["AdditionalLanguages"][1] end,
			multiline = false,
			width = 'full',
			order = 1
		},
		language2 = {
			type = "input",
			name = L["L_OPTIONS_LANGUAGES_2"],
			desc = "",
			disabled = function(info) return not GnomTEC_Babel_Options["Enabled"] end,
			set = function(info,val) GnomTEC_Babel_Options["AdditionalLanguages"][2] = val end,
	   	get = function(info) return GnomTEC_Babel_Options["AdditionalLanguages"][2] end,
			multiline = false,
			width = 'full',
			order = 1
		},
		language3 = {
			type = "input",
			name = L["L_OPTIONS_LANGUAGES_3"],
			desc = "",
			disabled = function(info) return not GnomTEC_Babel_Options["Enabled"] end,
			set = function(info,val) GnomTEC_Babel_Options["AdditionalLanguages"][3] = val end,
	   	get = function(info) return GnomTEC_Babel_Options["AdditionalLanguages"][3] end,
			multiline = false,
			width = 'full',
			order = 1
		},
		language4 = {
			type = "input",
			name = L["L_OPTIONS_LANGUAGES_4"],
			desc = "",
			disabled = function(info) return not GnomTEC_Babel_Options["Enabled"] end,
			set = function(info,val) GnomTEC_Babel_Options["AdditionalLanguages"][4] = val end,
	   	get = function(info) return GnomTEC_Babel_Options["AdditionalLanguages"][4] end,
			multiline = false,
			width = 'full',
			order = 1
		},
		language5 = {
			type = "input",
			name = L["L_OPTIONS_LANGUAGES_5"],
			desc = "",
			disabled = function(info) return not GnomTEC_Babel_Options["Enabled"] end,
			set = function(info,val) GnomTEC_Babel_Options["AdditionalLanguages"][5] = val end,
	   	get = function(info) return GnomTEC_Babel_Options["AdditionalLanguages"][5] end,
			multiline = false,
			width = 'full',
			order = 1
		},
	}
}
	
-- ----------------------------------------------------------------------
-- Startup initialization
-- ----------------------------------------------------------------------

GnomTEC_Babel = LibStub("AceAddon-3.0"):NewAddon("GnomTEC_Babel", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Babel Main", optionsMain)
LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Babel Languages", optionsLanguages)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Babel Main", "GnomTEC Babel");
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Babel Languages", L["L_OPTIONS_LANGUAGES"], "GnomTEC Babel");

-- ----------------------------------------------------------------------
-- Local functions
-- ----------------------------------------------------------------------

-- function which returns also nil for empty strings
local function emptynil( x ) return x ~= "" and x or nil end

function GnomTEC_Babel:SetLanguage(ID)
	local i = 1
	local languageName, languageID
	GnomTEC_Babel_Options["LanguageID"] = ID
	
	if (ID < 0) then
		if (GnomTEC_Babel_Options["Enabled"] and (nil ~= emptynil(GnomTEC_Babel_Options["AdditionalLanguages"][-ID]))) then
			languageName = GnomTEC_Babel_Options["AdditionalLanguages"][-ID]
		else	
			languageName, GnomTEC_Babel_Options["LanguageID"] = GetLanguageByIndex(1)
		end		
	else
		repeat
			languageName, languageID = GetLanguageByIndex(i)
			if (languageID == GnomTEC_Babel_Options["LanguageID"]) then
				i = 0
			else
				i = i + 1
			end
		until ((i < 1) or (i > GetNumLanguages()))
		if (i > 0) then
			-- we can not speak the given language so change to the first one
			languageName, GnomTEC_Babel_Options["LanguageID"] = GetLanguageByIndex(1)
		end
	end
 	GNOMTEC_BABEL_FRAME_SELECTLANGUAGE_BUTTON:SetText(languageName or "")
 	return languageName
end


-- ----------------------------------------------------------------------
-- Frame event handler and functions
-- ----------------------------------------------------------------------

-- initialize drop down menu languages
local function GnomTEC_Babel_SelectLanguage_InitializeDropDown(level)
	local i = 1
	local language = {
		notCheckable = 1,
		func = function (self, arg1, arg2, checked) GnomTEC_Babel:SetLanguage(arg2) end
	}
	-- to fix issue at login with sometimes returned nil
	local numLanguages = GetNumLanguages() or 1

	repeat
		language.arg1, language.arg2 = GetLanguageByIndex(i)	
		language.text = language.arg1
		UIDropDownMenu_AddButton(language)
		i = i + 1
	until (i > numLanguages)
	
	i = 1
	if (GnomTEC_Babel_Options["Enabled"]) then
		repeat
			if (nil ~= emptynil(GnomTEC_Babel_Options["AdditionalLanguages"][i])) then
				language.arg1 = GnomTEC_Babel_Options["AdditionalLanguages"][i]	
				language.arg2 = -i
				language.text = language.arg1
				UIDropDownMenu_AddButton(language)
			end
			i = i + 1
		until (i > MaxUserDefinedLanguages)
	end
end

-- select languages drop down menu OnLoad
function GnomTEC_Babel:SelectLanguage_DropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, GnomTEC_Babel_SelectLanguage_InitializeDropDown, "MENU")
end

-- select languages drop down menu OnClick
function GnomTEC_Babel:SelectLanguage_Button_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_BABEL_FRAME_SELECTLANGUAGE_DROPDOWN, self:GetName(), 0, 0)
end

-- ----------------------------------------------------------------------
-- Hook functions
-- ----------------------------------------------------------------------
function GnomTEC_Babel:Translate(msg, chatType, languageID, channel)	
	if ((chatType == "SAY") or (chatType == "YELL")) then
		if (GnomTEC_Babel_Options["LanguageSelectorEnabled"]) then
			-- check if we know this language yet, when not will be reset to common
			GnomTEC_Babel:SetLanguage(GnomTEC_Babel_Options["LanguageID"])
			languageID = GnomTEC_Babel_Options["LanguageID"]
		end
		if (GnomTEC_Babel_Options["Enabled"]) then
			if ((not languageID) or (LANGUAGE_ORCISH == languageID) or (LANGUAGE_COMMON == languageID)) then
				self.hooks.SendChatMessage(msg,chatType,nil, channel)
			else
				if (languageID < 0) then
					self.hooks.SendChatMessage("["..GnomTEC_Babel_Options["AdditionalLanguages"][-languageID].."] "..msg,chatType,nil, channel)
				else				
					self.hooks.SendChatMessage("["..GnomTEC_Babel:SetLanguage(languageID).."] "..msg,chatType,nil, channel)
				end
			end
		else
			self.hooks.SendChatMessage(msg,chatType,languageID, channel)
		end
	else
		self.hooks.SendChatMessage(msg,chatType,languageID, channel)
	end
end

-- ----------------------------------------------------------------------
-- Event handler
-- ----------------------------------------------------------------------

-- ----------------------------------------------------------------------
-- Addon OnInitialize, OnEnable and OnDisable
-- ----------------------------------------------------------------------

function GnomTEC_Babel:OnInitialize()
 	-- Code that you want to run when the addon is first loaded goes here.
  
  	GnomTEC_Babel:Print(L["L_WELCOME"])
  	  	
end

function GnomTEC_Babel:OnEnable()
    -- Called when the addon is enabled

	GnomTEC_Babel:Print("GnomTEC_Babel Enabled")
	self:RawHook("SendChatMessage","Translate",true)

	-- Initialize options which are propably not valid because they are new added in new versions of addon
	if (nil == GnomTEC_Babel_Options["LanguageSelectorEnabled"]) then
		GnomTEC_Babel_Options["LanguageSelectorEnabled"] = GnomTEC_Babel_Options["Enabled"]
	end
	if (nil == GnomTEC_Babel_Options["LanguageID"]) then
		GnomTEC_Babel_Options["LanguageID"] = select(2, GetLanguageByIndex(1))
		GnomTEC_Babel_Options["Language"] = nil
	end
	if (nil == GnomTEC_Babel_Options["AdditionalLanguages"]) then
		GnomTEC_Babel_Options["AdditionalLanguages"] = {}
	end
		
	-- Show GUI
	if (GnomTEC_Babel_Options["LanguageSelectorEnabled"]) then
		GNOMTEC_BABEL_FRAME:Show()
	end

	GnomTEC_Babel:SetLanguage(GnomTEC_Babel_Options["LanguageID"])

end

function GnomTEC_Babel:OnDisable()
    -- Called when the addon is disabled
    
	GnomTEC_Babel:UnregisterAllEvents();
	GNOMTEC_BABEL_FRAME:Hide()

end

-- ----------------------------------------------------------------------
-- External API
-- ----------------------------------------------------------------------

